package jp.co.celestee.ai.interfaces.body;

import jp.co.celestee.ai.core.signal.PleasureIF;
import jp.co.celestee.ai.interfaces.input.AbstractDataCooperationSignal;
import jp.co.celestee.ai.interfaces.input.DefaultDataCooperationSignal;
import jp.co.celestee.external.event.DynamicToRuleEventConveter;
import jp.co.celestee.external.rule.dinamic.DynamicRuleData;

public class BodyDataConverter {

	/**
	 * [̎hf[^AI̓dCM֕ϊ܂B
	 * @param ruleData
	 * @return
	 */
	public static AbstractDataCooperationSignal change(DynamicRuleData ruleData) {
		
		int iFeel = getFeel(ruleData.getDynamic());
		int iPain = 0;
		
		if(iFeel == BodyFeelConst.INTO) {
			//hq͌ɂ̂ݎh^Ƃ
			iPain = getPain(ruleData.getType());
		}
		
		BodySignalData dData = new BodySignalData(iPain, iFeel);
		
		DefaultDataCooperationSignal signal = new DefaultDataCooperationSignal();
		signal.setElectricPotential(ruleData.getPotential());
		signal.setSignalData(dData);

		return signal;
	}

	private static int getPain(int type) {
		//-65536RED
		if(type != -65536) {
			return PleasureIF.PLEASURE_LEVEL;
		}
		else {
			return PleasureIF.DISPLEASURE_LEVEL;
		}
	}
	
	private static int getFeel(int dynamic) {
		if(dynamic == DynamicToRuleEventConveter.RECEIVED_ACTION) {
			return BodyFeelConst.RECEIVE;
		}
		else if(dynamic == DynamicToRuleEventConveter.BREAK_ACTION) {
			return BodyFeelConst.INTO;
		}
		
		return 0;
	}

	/**
	 * AI̐M[̎hf[^֕ϊ܂B
	 * @param signal
	 * @return
	 */
	public static DynamicRuleData change(AbstractDataCooperationSignal signal) {
		
		BodySignalData signalData = (BodySignalData)signal.getSignalData();
		
		DynamicRuleData ruleData = new DynamicRuleData();
		ruleData.setPotential(signal.getElectricPotential());
		ruleData.setDynamic(getDynamic(signalData.getFeel()));
		
		return ruleData;
	}

	private static int getDynamic(int feel) {
		if(feel == BodyFeelConst.WALK) {
			return DynamicToRuleEventConveter.GO_ACTION;
		}
		else if(feel == BodyFeelConst.TURN_RIGHT) {
			return DynamicToRuleEventConveter.TURN_RIGHT_ACTION;
		}
		else if(feel == BodyFeelConst.EAT) {
			return DynamicToRuleEventConveter.ABSORPTION_ACTION;
		}
		else if(feel == BodyFeelConst.TURN_LEFT) {
			return DynamicToRuleEventConveter.TURN_LEFT_ACTION;
		}
		else if(feel == BodyFeelConst.PICKUP) {
			return DynamicToRuleEventConveter.LIFT_ACTION;
		}
		
		return 0;
	}
}
