package jp.co.celestee.ai.interfaces.body;

import java.lang.reflect.Field;
import java.util.List;

import jp.co.celestee.ai.core.signal.AbstractSignalData;
import jp.co.celestee.ai.core.signal.SignalDataIF;

public class BodySignalData extends AbstractSignalData {
	
	private static final long serialVersionUID = 1L;

	/** G */
	private int feel = 0;
	
	/** Ɋo */
	private int pain = 0;
	
	public BodySignalData() {
	}

	public BodySignalData(int pain, int feel) {
		this.feel = feel;
		this.pain = pain;
	}
	
	@Override
	public Class<?> getOutputIdClass() {
		return null;
	}

	public int getFeel() {
		return feel;
	}

	public void setFeel(int feel) {
		this.feel = feel;
	}

	public int getPain() {
		return pain;
	}

	public void setPain(int pain) {
		this.pain = pain;
	}

	@Override
	public List<SignalDataIF> getPartsSignalDataList() {
		return null;
	}
	
	@Override
	public String toString() {
		Field[] fields = BodyFeelConst.class.getDeclaredFields();
		
		String feelString = null;
		
		try {
			for(Field field : fields) {
				if(feel == field.getInt(null)) {
					FeelInformation info = field.getAnnotation(FeelInformation.class);
					feelString = info.value();
					break;
				}
			}
		}
		catch(Exception e) {
			e.printStackTrace();
			feelString = e.toString();
		}
		
		return "(FEEL=" + feelString + ", In=" + isInner() + ")";
	}

	@Override
	public boolean equals(Object target) {
		boolean b = super.equals(target);
		if(b == false) return b;
		
		if(target instanceof BodySignalData) {
			BodySignalData data = (BodySignalData)target;
			boolean bfeel = feel == data.getFeel();
			boolean bpain = pain == data.getPain();
			return bfeel && bpain;
		}
		
		return false;
	}
	
	@Override
	public int hashCode() {
		return 0;
	}

	@Override
	public String getSupposingItSaysInMansWords() {
		if(getFeel() == BodyFeelConst.INTO) {
			return "eating";
		}
		else if(getFeel() == BodyFeelConst.RECEIVE) {
			return "gathering";
		}
		else {
			return "undefined";
		}
	}

}
