package jp.co.celestee.ai.interfaces.characterin;

import java.util.HashMap;
import java.util.Map;

import jp.co.celestee.ai.interfaces.input.AbstractDataCooperationSignal;

/**
 * GRCbN[̗lɈꎞIɃf[^ۑ܂B
 * @author celestee
 *
 */
public class CharacterInMemory {

	private static int WAIT_TIME = 50;
	
	private static CharacterInMemory _ciMemory = new CharacterInMemory();
	
	/** GRCbN[ */
	private Map<Integer, String> _memoryMap = new HashMap<Integer, String>();

	private CharacterInMemory() {
		
	}
	
	public static CharacterInMemory getInstance() {
		return _ciMemory;
	}
	
	/**
	 * Zbgf[^o܂B
	 * ܂Aof[^͍폜܂B
	 * @return
	 */
	private CharacterInSignalData getMemory(CharacterInSignalData signalData) {
		
		synchronized(_memoryMap) {
			Object oValue = _memoryMap.get(signalData.getType());
			if(oValue != null) {
				signalData.setContents((String)oValue);
				_memoryMap.remove(signalData.getType());
			}
			
			return signalData;
		}
	}

	/**
	 * GRCbN[ɕۑ܂B
	 * ɕۑꂽ̂ŕł΍܂B
	 * @param sMemory
	 */
	private void setMemory(CharacterInSignalData signalData) {
		synchronized(_memoryMap) {
			Object oValue = _memoryMap.get(signalData.getType());
			if(oValue == null) {
				_memoryMap.put(signalData.getType(), signalData.getContents());
			}
			else {
				_memoryMap.put(signalData.getType(), oValue + signalData.getContents());
			}
		}
	}
	
	/**
	 * iINjIFւ͕̂KGRCbN[ʂ
	 * @param signalData
	 */
	public void throughMemory(AbstractDataCooperationSignal signal) {
		
		CharacterInSignalData cisData = (CharacterInSignalData)signal.getSignalData();
		
		//GRCbN[ɕۑ
		CharacterInMemory.getInstance().setMemory(cisData);
		
		try{
			Thread.sleep(WAIT_TIME);
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		
		//GRCbN[獇ʂoAVOiɐݒ
		signal.setSignalData(CharacterInMemory.getInstance().getMemory(cisData));

	}
	
	
}
