package jp.co.celestee.ai.interfaces.image;

import java.awt.Polygon;
import java.util.Arrays;


public class ImagePolygon extends Polygon {

	private static final long serialVersionUID = 1L;

	private int[] xpoints = null;
	private int[] ypoints = null;
	private int addX = 0;
	private int addY = 0;
	private String polygonName = null;
	
	public ImagePolygon(int[] x, int[] y, int length, int addx, int addy, String name) {
		super(x, y, length);
		xpoints = x;
		ypoints = y;
		addX = addx;
		addY = addy;
		polygonName = name;
	}
	
	@Override
	public String toString() {
		return polygonName + " " + addX + "," + addY;
	}

	@Override
	public boolean equals(Object target) {
		boolean b = super.equals(target);
		if(b) return b;
		
		if(target instanceof ImagePolygon) {
			ImagePolygon polygon = (ImagePolygon)target;
			boolean bX = xpoints == null ? polygon.xpoints == null : Arrays.equals(xpoints, polygon.xpoints);
			boolean bY = ypoints == null ? polygon.ypoints == null : Arrays.equals(ypoints, polygon.ypoints);
			boolean bAddX = addX == polygon.addX;
			boolean bAddY = addY == polygon.addY;
			boolean bName = polygonName == null ? polygon.polygonName == null : polygonName.equals(polygon.polygonName);
			
			return bX && bY && bAddX && bAddY && bName;
		}
		
		return false;
	}

}
