package jp.co.celestee.ai.interfaces.image;

import jp.co.celestee.ai.interfaces.AbstractSubstance;
import jp.co.celestee.ai.interfaces.input.DefaultDataCooperationSignal;
import jp.co.celestee.ai.interfaces.status.JFrontRetina;
import jp.co.celestee.ai.interfaces.status.JRetina;
import jp.co.celestee.external.rule.RuleDataIF;
import jp.co.celestee.external.rule.light.LightRuleAccessorIF;
import jp.co.celestee.external.rule.light.LightRuleData;

/**
 * 摜IF̖{̏łB
 * @author celestee
 *
 */
public class ImageSubstance extends AbstractSubstance implements LightRuleAccessorIF {

	private static ImageSubstance subInstance = new ImageSubstance();
	
	private ImageSubstance() {}
	
	public static ImageSubstance getInstance() {
		return subInstance;
	}

	/**
	 * [IFւ̓
	 */
	@Override
	public void inputLight(LightRuleData ruleData) {
		inputDataFromRule(ruleData);
	}

	/**
	 * [IFւ̓
	 */
	@Override
	public void inputFromRule(RuleDataIF ruleData, Signals signals) {

		LightRuleData imageRuleData = (LightRuleData)ruleData;

		//IFŃf[^ϊiዅŌԖ̓Ɠj
		DefaultDataCooperationSignal dcSignal = ImageDataConverter.change(imageRuleData);
		signals.setDataCooperationSignal(dcSignal);
		
		//System.out.println("+++ " + dcSignal.getSignalData());
	}

	@Override
	public void inputFromAI(Object aiData, Signals signals) {
		//AI-IFԂŎvoĂ
		signals.setDataCooperationSignal((DefaultDataCooperationSignal)aiData);
	}

	@Override
	public void process(Signals signals) {
		//ACRjbN[ʂ
		
		//Ԗ摜[Uɕ\
		JRetina retina = JFrontRetina.getInstance();
		ImageSignalData signalData = (ImageSignalData)signals.getDataCooperationSignal().getSignalData();
		retina.setColor(signalData.getColor());
		retina.setPolygon(signalData.getPolygon());
		retina.repaint();
		
		//System.out.println("" + signalData);
	}

	@Override
	public void outputToRule(Signals signals) {
		//[ւ̏o͂͂Ȃ

	}

}
