package jp.co.celestee.ai.interfaces.status;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

import jp.co.celestee.ai.core.AICoreConst;
import jp.co.celestee.ai.core.embed.DesireEmbeder;
import jp.co.celestee.ai.core.embed.PhysicalDesirePreInstaller;
import jp.co.celestee.ai.core.embed.RunningEducationModeException;
import jp.co.celestee.ai.core.nerve.DesireNerveIF;
import jp.co.celestee.ai.core.nerve.NerveIF;
import jp.co.celestee.ai.external.debug.DevelopHelper;
import jp.co.celestee.ai.interfaces.MemoryControler;
import jp.co.celestee.ai.interfaces.body.id.BodyEatId;
import jp.co.celestee.ai.interfaces.body.id.BodyPickupId;
import jp.co.celestee.ai.interfaces.body.id.BodyTurnLeftId;
import jp.co.celestee.ai.interfaces.body.id.BodyTurnRightId;
import jp.co.celestee.ai.interfaces.body.id.BodyWalkId;
import jp.co.celestee.ai.interfaces.characterin.CharacterInOutputId;
import jp.co.celestee.ai.interfaces.characterout.CharacterOutOutputId;
import jp.co.celestee.ai.interfaces.constant.PhysicalDesireConst;
import jp.co.celestee.ai.interfaces.image.ImageOutputId;
import jp.co.celestee.external.object.LightGenerator;

@SuppressWarnings("serial")
public class JStatusFrame extends JFrame implements ActionListener{

	private static final boolean bRelease = false;
	
	private static JTextArea MAX_DESIRE_AREA = null;
	private static JTextArea VIEW_PLAN_AREA = null;
	private static JTextArea STATUS_AREA = null;
	private static JTextArea TEMPT_AREA = null;
	private static JTextArea SIGNAL_AREA = null;
	private static JTextArea PLAN_AREA = null;
	private static JTextArea RECORD_AREA = null;
	
	private static JTextField TEMPT_NERVE_ID_FIELD = null;
	private static JTextField TEMPT_LEVEL_CHANGE_FIELD = null;
	private static JTextField COMMON_PLAN_REMOVE_FIELD = null;
	private static JStatusMeter SIGNAL_METER = null;
	private static JStatusMeter ENERGY_METER = null;

	JButton walkButton = null;
	JButton turnRightButton = null;
	JButton turnLeftButton = null;
	JButton eatButton = null;
	JButton pickButton = null;

	JCheckBox nerveCheck = null;
	JCheckBox desireCheck  = null;
	JCheckBox physicalDesireCheck  = null;
	JCheckBox partsCheck = null;

	JCheckBox walkCheck = null;
	JCheckBox turnCheck = null;
	JCheckBox eatCheck = null;
	JCheckBox pickCheck = null;
	JCheckBox imageCheck = null;
	JCheckBox charInCheck = null;
	JCheckBox charOutCheck = null;

	JButton temptChangeButton = null;
	JButton commonPlanRemoveButton = null;
	JButton saveMemoryButton = null;
	JButton loadMemoryButton = null;
	JButton recodeSignalButton = null;
	JButton stopRecodeButton = null;
	JButton startEducationButton = null;

	@SuppressWarnings("unused")
	public JStatusFrame() {
		JPanel basePane = new JPanel();
		getContentPane().add(basePane);
		
		basePane.setLayout(new BoxLayout(basePane, BoxLayout.X_AXIS));
		basePane.setSize(500, 720);
		
		JPanel statusPane = new JPanel();
		statusPane.setLayout(new BoxLayout(statusPane, BoxLayout.Y_AXIS));
		statusPane.setSize(280, 720);
		basePane.add(statusPane);

		//AI֖ߍ񂾋@B擾\pl
		JPanel embedPane = new JPanel();
		embedPane.setLayout(new BoxLayout(embedPane, BoxLayout.X_AXIS));
		embedPane.setSize(280, 720);
		statusPane.add(embedPane);

		JPanel embedModePane = new JPanel();
		embedModePane.setLayout(new BoxLayout(embedModePane, BoxLayout.X_AXIS));
		embedModePane.setSize(280, 720);
		statusPane.add(embedModePane);

		//AI View
		embedPane.add(new JLabel("AI View "));
		JFrontRetina retina = JFrontRetina.getInstance();
		retina.setBorder(BorderFactory.createLoweredBevelBorder());
		JScrollPane scrollPane1 = new JScrollPane(retina);
		scrollPane1.setPreferredSize(new Dimension(31, 31));
		scrollPane1.setMaximumSize(new Dimension(31, 31));
		scrollPane1.setMinimumSize(new Dimension(31, 31));
		embedPane.add(scrollPane1);

		embedPane.add(new JLabel("Command "));

		walkButton = new JButton("Walk");
		walkButton.addActionListener(this);
		walkButton.setMinimumSize(new Dimension(70, 25));
		walkButton.setMaximumSize(new Dimension(70, 25));
		embedPane.add(walkButton);

		turnLeftButton = new JButton("TurnL");
		turnLeftButton.addActionListener(this);
		turnLeftButton.setMinimumSize(new Dimension(70, 25));
		turnLeftButton.setMaximumSize(new Dimension(70, 25));
		embedPane.add(turnLeftButton);

		turnRightButton = new JButton("TurnR");
		turnRightButton.addActionListener(this);
		turnRightButton.setMinimumSize(new Dimension(70, 25));
		turnRightButton.setMaximumSize(new Dimension(70, 25));
		embedPane.add(turnRightButton);

		eatButton = new JButton("Eat");
		eatButton.addActionListener(this);
		eatButton.setMinimumSize(new Dimension(70, 25));
		eatButton.setMaximumSize(new Dimension(70, 25));
		embedPane.add(eatButton);

		pickButton = new JButton("Pick");
		pickButton.addActionListener(this);
		pickButton.setMinimumSize(new Dimension(70, 25));
		pickButton.setMaximumSize(new Dimension(70, 25));
		embedPane.add(pickButton);

		//[hpl

		//Education mode
		JCheckBox educationCheck = new JCheckBox("Education mode", true);
		educationCheck.addActionListener(this);
		educationCheck.setActionCommand("educationCheck");
		embedModePane.add(educationCheck);
		
		//Pre-installation mode
		JCheckBox defaultModeCheck = new JCheckBox("Pre-installation mode", false);
		defaultModeCheck.addActionListener(this);
		defaultModeCheck.setActionCommand("preinstallCheck");
		embedModePane.add(defaultModeCheck);

		//Xe[^Xpl
		JTabbedPane tabbedpane = new JTabbedPane();
		statusPane.add(tabbedpane);
		
		//OtBJXe[^X
		JPanel statusGPanel = new JPanel();
		statusGPanel.setLayout(new BoxLayout(statusGPanel, BoxLayout.Y_AXIS));
		
		statusGPanel.add(new JLabel("[ Signal meter ]"));
		
		SIGNAL_METER = new JStatusMeter();
		SIGNAL_METER.setColor(Color.blue, new Color(200, 200, 255), Color.white);
		//SIGNAL_METER.setMinimumSize(new Dimension(400, 12));
		SIGNAL_METER.setMaximumSize(new Dimension(800, 12));
		statusGPanel.add(SIGNAL_METER);

		statusGPanel.add(new JLabel("[ Energy meter ]"));
		
		ENERGY_METER = new JStatusMeter();
		ENERGY_METER.setColor(Color.yellow, new Color(255, 255, 235), Color.black);
		//ENERGY_METER.setMinimumSize(new Dimension(400, 12));
		ENERGY_METER.setMaximumSize(new Dimension(800, 12));
		statusGPanel.add(ENERGY_METER);

		statusGPanel.add(new JLabel(" "));

		statusGPanel.add(new JLabel("[ save memory ]"));

		saveMemoryButton = new JButton("save memory");
		saveMemoryButton.setActionCommand("savememory");
		saveMemoryButton.setMaximumSize(new Dimension(170, 20));
		saveMemoryButton.addActionListener(this);
		statusGPanel.add(saveMemoryButton);
		
		statusGPanel.add(new JLabel("[ load memory ]"));

		loadMemoryButton = new JButton("load memory");
		loadMemoryButton.setActionCommand("loadmemory");
		loadMemoryButton.setMaximumSize(new Dimension(170, 20));
		loadMemoryButton.addActionListener(this);
		statusGPanel.add(loadMemoryButton);

		statusGPanel.add(new JLabel(" "));

		statusGPanel.add(new JLabel("[ recode signal ]"));

		recodeSignalButton = new JButton("recode signal");
		recodeSignalButton.setActionCommand("recodesignal");
		recodeSignalButton.setMaximumSize(new Dimension(170, 20));
		recodeSignalButton.addActionListener(this);
		statusGPanel.add(recodeSignalButton);
		
		statusGPanel.add(new JLabel("[ stop recode signal ]"));

		stopRecodeButton = new JButton("stop recode");
		stopRecodeButton.setActionCommand("stoprecode");
		stopRecodeButton.setMaximumSize(new Dimension(170, 20));
		stopRecodeButton.addActionListener(this);
		statusGPanel.add(stopRecodeButton);

		statusGPanel.add(new JLabel("[ education signal ]"));

		startEducationButton = new JButton("start education");
		startEducationButton.setActionCommand("starteducation");
		startEducationButton.setMaximumSize(new Dimension(170, 20));
		startEducationButton.addActionListener(this);
		statusGPanel.add(startEducationButton);

		tabbedpane.addTab("Status", statusGPanel);

		JPanel thinkViewPanel = new JPanel();
		thinkViewPanel.setLayout(new BoxLayout(thinkViewPanel, BoxLayout.Y_AXIS));

		thinkViewPanel.add(new JLabel("[ Something to do ]"));
		MAX_DESIRE_AREA = new JTextArea(22, 2);
		MAX_DESIRE_AREA.setEditable(false);
		JScrollPane scrollPane7 = new JScrollPane(MAX_DESIRE_AREA);
		scrollPane7.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane7.setPreferredSize(new Dimension(300, 100));
		thinkViewPanel.add(scrollPane7);
		
		thinkViewPanel.add(new JLabel(" "));

		thinkViewPanel.add(new JLabel("[ Plan ] <It displays, only when planned.>"));
		VIEW_PLAN_AREA = new JTextArea(22, 28);
		VIEW_PLAN_AREA.setEditable(false);
		JScrollPane scrollPane8 = new JScrollPane(VIEW_PLAN_AREA);
		scrollPane8.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane8.setPreferredSize(new Dimension(300, 620));
		thinkViewPanel.add(scrollPane8);

		tabbedpane.addTab("Think", thinkViewPanel);
		
		//Azԕ\p̃^u
		STATUS_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane2 = new JScrollPane(STATUS_AREA);
		scrollPane2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane2.setPreferredSize(new Dimension(300, 720));
		if(bRelease == false) {
			tabbedpane.addTab("Nerve", scrollPane2);
		}
		
		//Ü
		TEMPT_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane3 = new JScrollPane(TEMPT_AREA);
		scrollPane3.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane3.setPreferredSize(new Dimension(300, 720));
		if(bRelease == false) {
			tabbedpane.addTab("Tempt", scrollPane3);
		}

		//VOi
		SIGNAL_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane4 = new JScrollPane(SIGNAL_AREA);
		scrollPane4.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane4.setPreferredSize(new Dimension(300, 720));
		if(bRelease == false) {
			tabbedpane.addTab("Signal", scrollPane4);
		}

		//v
		PLAN_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane5 = new JScrollPane(PLAN_AREA);
		scrollPane5.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane5.setPreferredSize(new Dimension(300, 720));
		if(bRelease == false) {
			tabbedpane.addTab("Plan", scrollPane5);
		}

		//sʋL^
		RECORD_AREA = new JTextArea(22, 22);
		JScrollPane scrollPane6 = new JScrollPane(RECORD_AREA);
		scrollPane6.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane6.setPreferredSize(new Dimension(300, 720));
		if(bRelease == false) {
			tabbedpane.addTab("Record", scrollPane6);
		}
		
		//AzԂ̕\^u
		JPanel associationSettingPanel = new JPanel();
		associationSettingPanel.setLayout(new BoxLayout(associationSettingPanel, BoxLayout.Y_AXIS));
		
		associationSettingPanel.add(new JLabel("[ Nerve view setting ]"));
		
		//
		JSeparator separator0 = new JSeparator(SwingConstants.HORIZONTAL);
		separator0.setMaximumSize(new Dimension(800, 10));
		associationSettingPanel.add(separator0);

		nerveCheck = new JCheckBox("Association Nerve View", false);
		desireCheck  = new JCheckBox("Environment Desire Nerve View", true);
		physicalDesireCheck  = new JCheckBox("Physical Desire Nerve View", false);
		partsCheck = new JCheckBox("Nerve Parts View", false);
		nerveCheck.setActionCommand("nerveCheck");
		desireCheck.setActionCommand("desireCheck");
		physicalDesireCheck.setActionCommand("physicalDesireCheck");
		partsCheck.setActionCommand("partsCheck");
		associationSettingPanel.add(nerveCheck);
		associationSettingPanel.add(desireCheck);
		associationSettingPanel.add(physicalDesireCheck);
		associationSettingPanel.add(partsCheck);
		nerveCheck.addActionListener(this);
		desireCheck.addActionListener(this);
		physicalDesireCheck.addActionListener(this);
		partsCheck.addActionListener(this);

		//
		JSeparator separator1 = new JSeparator(SwingConstants.HORIZONTAL);
		separator1.setMaximumSize(new Dimension(400, 10));
		associationSettingPanel.add(separator1);

		//OUTPUTID
		walkCheck = new JCheckBox("WALK view", true);
		turnCheck = new JCheckBox("TURN view", true);
		eatCheck = new JCheckBox("EAT view", true);
		pickCheck = new JCheckBox("PICK UP view", true);
		imageCheck = new JCheckBox("IMAGE view", false);
		charInCheck = new JCheckBox("CHAR_IN view", false);
		charOutCheck = new JCheckBox("CHAR_OUT view", true);
		walkCheck.setActionCommand("walkCheck");
		turnCheck.setActionCommand("turnCheck");
		eatCheck.setActionCommand("eatCheck");
		pickCheck.setActionCommand("pickCheck");
		imageCheck.setActionCommand("imageCheck");
		charInCheck.setActionCommand("charInCheck");
		charOutCheck.setActionCommand("charOutCheck");
		associationSettingPanel.add(walkCheck);
		associationSettingPanel.add(turnCheck);
		associationSettingPanel.add(eatCheck);
		associationSettingPanel.add(pickCheck);
		associationSettingPanel.add(imageCheck);
		associationSettingPanel.add(charInCheck);
		associationSettingPanel.add(charOutCheck);
		walkCheck.addActionListener(this);
		turnCheck.addActionListener(this);
		eatCheck.addActionListener(this);
		pickCheck.addActionListener(this);
		imageCheck.addActionListener(this);
		charInCheck.addActionListener(this);
		charOutCheck.addActionListener(this);
		
		DevelopHelper.addDebugOutputID(BodyWalkId.class);
		DevelopHelper.addDebugOutputID(BodyTurnRightId.class);
		DevelopHelper.addDebugOutputID(BodyTurnLeftId.class);
		DevelopHelper.addDebugOutputID(BodyEatId.class);
		DevelopHelper.addDebugOutputID(BodyPickupId.class);
		DevelopHelper.addDebugOutputID(CharacterOutOutputId.class);

		
		//
		JSeparator separator5 = new JSeparator(SwingConstants.HORIZONTAL);
		separator5.setMaximumSize(new Dimension(400, 10));
		associationSettingPanel.add(separator5);
		
		JCheckBox reverseCheck = new JCheckBox("connection view");
		reverseCheck.addActionListener(this);
		reverseCheck.setActionCommand("reverseCheck");
		associationSettingPanel.add(reverseCheck);

		//
		JSeparator separator2 = new JSeparator(SwingConstants.HORIZONTAL);
		separator2.setMaximumSize(new Dimension(400, 10));
		associationSettingPanel.add(separator2);

		JCheckBox temptCheck = new JCheckBox("tempt level view", true);
		temptCheck.addActionListener(this);
		temptCheck.setActionCommand("temptCheck");
		associationSettingPanel.add(temptCheck);
		
		//
		JSeparator separator3 = new JSeparator(SwingConstants.HORIZONTAL);
		separator3.setMaximumSize(new Dimension(400, 20));
		associationSettingPanel.add(separator3);

		associationSettingPanel.add(new JLabel("[ Temptation zone / Success plan view setting ]"));
		
		//
		JSeparator separator4 = new JSeparator(SwingConstants.HORIZONTAL);
		separator4.setMaximumSize(new Dimension(800, 10));
		associationSettingPanel.add(separator4);

		associationSettingPanel.add(new JLabel("The desire specified below is displayed.(Tempt Tab)"));
		associationSettingPanel.add(new JLabel("Experience of the past of the desire specified below is displayed.(Plan Tab)"));
		associationSettingPanel.add(new JLabel("When specified ID is not found, the maximum desire instance is displayed."));
		TEMPT_NERVE_ID_FIELD = new JTextField("Please set up here ID of the desire nerve displayed on (Tempt/Plan)View.", 5);
		TEMPT_NERVE_ID_FIELD.setMaximumSize(new Dimension(800, 20));
		associationSettingPanel.add(TEMPT_NERVE_ID_FIELD);

		associationSettingPanel.add(new JLabel("The Temptation level of ID specified above can be changed into below."));
		TEMPT_LEVEL_CHANGE_FIELD = new JTextField();
		TEMPT_LEVEL_CHANGE_FIELD.setMaximumSize(new Dimension(100, 20));
		associationSettingPanel.add(TEMPT_LEVEL_CHANGE_FIELD);
		temptChangeButton = new JButton("change");
		temptChangeButton.setActionCommand("changeTempt");
		temptChangeButton.setMaximumSize(new Dimension(100, 20));
		temptChangeButton.addActionListener(this);
		associationSettingPanel.add(temptChangeButton);

		//commonPlan remove
		associationSettingPanel.add(new JLabel("A part of commonPlan of ID specified above can be deleted (Index is specified)."));
		COMMON_PLAN_REMOVE_FIELD = new JTextField();
		COMMON_PLAN_REMOVE_FIELD.setMaximumSize(new Dimension(100, 20));
		associationSettingPanel.add(COMMON_PLAN_REMOVE_FIELD);
		commonPlanRemoveButton = new JButton("remove");
		commonPlanRemoveButton.setActionCommand("removeCommonPlan");
		commonPlanRemoveButton.setMaximumSize(new Dimension(100, 20));
		commonPlanRemoveButton.addActionListener(this);
		associationSettingPanel.add(commonPlanRemoveButton);

		if(bRelease == false) {
			tabbedpane.addTab("settings", associationSettingPanel);
		}

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("AI Status Watcher");
		setSize(500, 720);
		setVisible(true);
		//setAlwaysOnTop(true);
		
	}
	
	public static void setMaxDesireText(String str) {
		MAX_DESIRE_AREA.setText(str);
	}
	
	public static void setViewPlanText(String str) {
		VIEW_PLAN_AREA.setText(str);
	}
	
	public static void setStatusText(String statusStr) {
		STATUS_AREA.setText(statusStr);
	}

	public static void setSignalText(String signalStr) {
		SIGNAL_AREA.setText(signalStr);
	}

	public static void setPlanText(String planStr) {
		PLAN_AREA.setText(planStr);
	}

	public static void setRecordText(String recordStr) {
		RECORD_AREA.setText(recordStr);
	}

	public static void setTemptText(String temptStr) {
		TEMPT_AREA.setText(temptStr);
	}

	public static long getTemptNerveID() {
		String s = TEMPT_NERVE_ID_FIELD.getText();
		try {
			return Long.parseLong(s);
		}
		catch(NumberFormatException e) {
			return 0;
		}
	}
	
	public static void setAssociationStatusCount(int value, int max) {
		SIGNAL_METER.setValue(value, max);
		SIGNAL_METER.repaint();
	}
	
	public static void setEnergyMeter(int value, int max) {
		ENERGY_METER.setValue(value, max);
		ENERGY_METER.repaint();
	}

	public void actionPerformed(ActionEvent e){
		//System.out.println(e.getActionCommand());
		
		String command = e.getActionCommand();
		
		if("nerveCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			DevelopHelper.setDebugViewvNerve(box.isSelected());
		}
		else if("desireCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			DevelopHelper.setDebugViewvDesireNerve(box.isSelected());
		}
		else if("physicalDesireCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			DevelopHelper.setDebugViewvPhysicalNerve(box.isSelected());
		}
		else if("partsCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			DevelopHelper.setDebugViewvPartsNerve(box.isSelected());
		}
		else if("reverseCheck".equals(command)) {
			JCheckBox checkBox = (JCheckBox)e.getSource();
			DevelopHelper.setDebugReverseNerveView(checkBox.isSelected());
		}
		else if("temptCheck".equals(command)) {
			JCheckBox checkBox = (JCheckBox)e.getSource();
			DevelopHelper.setDebugTemptView(checkBox.isSelected());
		}
		else if("educationCheck".equals(command)) {
			JCheckBox checkBox = (JCheckBox)e.getSource();
			try {
				DesireEmbeder.setEducationMode(checkBox.isSelected());
				walkButton.setEnabled(checkBox.isSelected());
				turnRightButton.setEnabled(checkBox.isSelected());
				turnLeftButton.setEnabled(checkBox.isSelected());
				eatButton.setEnabled(checkBox.isSelected());
				pickButton.setEnabled(checkBox.isSelected());
			}
			catch(RunningEducationModeException reme) {
				JFrame frame = new JFrame("Warning");
				frame.addWindowListener(new WindowAdapter() {
					public void windowClosing(WindowEvent e) { 
						System.exit(0); 
					}
				});
				frame.setSize(new Dimension(300,200));
				frame.setVisible(true);
				JOptionPane.showMessageDialog(frame, "瓮쒆ׁ̈A烂[hύXł܂BԂoĂĎsĂB");

			}
		}
		else if("preinstallCheck".equals(command)) {
			JCheckBox checkBox = (JCheckBox)e.getSource();
			PhysicalDesirePreInstaller.setPreInstallationMode(checkBox.isSelected());
		}
		else if("Walk".equals(command)) {
			DesireEmbeder.add(PhysicalDesireConst.WALK_DESIRE);
		}
		else if("TurnL".equals(command)) {
			DesireEmbeder.add(PhysicalDesireConst.TURN_LEFT_DESIRE);
		}
		else if("TurnR".equals(command)) {
			DesireEmbeder.add(PhysicalDesireConst.TURN_RIGHT_DESIRE);
		}
		else if("Eat".equals(command)) {
			DesireEmbeder.add(PhysicalDesireConst.EAT_DESIRE);
		}
		else if("Pick".equals(command)) {
			DesireEmbeder.add(PhysicalDesireConst.PICKUP_DESIRE);
		}
		else if("walkCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			if(box.isSelected()) {
				DevelopHelper.addDebugOutputID(BodyWalkId.class);
			}
			else {
				DevelopHelper.removeDebugOutputID(BodyWalkId.class);
			}
		}
		else if("turnCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			if(box.isSelected()) {
				DevelopHelper.addDebugOutputID(BodyTurnRightId.class);
				DevelopHelper.addDebugOutputID(BodyTurnLeftId.class);
			}
			else {
				DevelopHelper.removeDebugOutputID(BodyTurnRightId.class);
				DevelopHelper.removeDebugOutputID(BodyTurnLeftId.class);
			}
		}
		else if("eatCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			if(box.isSelected()) {
				DevelopHelper.addDebugOutputID(BodyEatId.class);
			}
			else {
				DevelopHelper.removeDebugOutputID(BodyEatId.class);
			}
		}
		else if("pickCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			if(box.isSelected()) {
				DevelopHelper.addDebugOutputID(BodyPickupId.class);
			}
			else {
				DevelopHelper.removeDebugOutputID(BodyPickupId.class);
			}
		}
		else if("imageCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			if(box.isSelected()) {
				DevelopHelper.addDebugOutputID(ImageOutputId.class);
			}
			else {
				DevelopHelper.removeDebugOutputID(ImageOutputId.class);
			}
		}
		else if("charInCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			if(box.isSelected()) {
				DevelopHelper.addDebugOutputID(CharacterInOutputId.class);
			}
			else {
				DevelopHelper.removeDebugOutputID(CharacterInOutputId.class);
			}
		}
		else if("charOutCheck".equals(command)) {
			JCheckBox box = (JCheckBox)e.getSource();
			if(box.isSelected()) {
				DevelopHelper.addDebugOutputID(CharacterOutOutputId.class);
			}
			else {
				DevelopHelper.removeDebugOutputID(CharacterOutOutputId.class);
			}
		}
		else if("changeTempt".equals(command)) {
			String id = TEMPT_NERVE_ID_FIELD.getText();
			NerveIF nerve = null;
			
			try{
				long key = Long.valueOf(id);
				nerve = DevelopHelper.searchNerve(key);

				if(nerve == null || (nerve instanceof DesireNerveIF) == false) {
					nerve = (NerveIF)DevelopHelper.getMaxDesireNerve();
				}
			}
			catch(Exception ex) {
				//őlɐݒ肷
				nerve = (NerveIF)DevelopHelper.getMaxDesireNerve();
			}
			
			if(nerve == null) {
				return;
			}
			
			int iLevel = 0;
			try {
				iLevel = Integer.valueOf(TEMPT_LEVEL_CHANGE_FIELD.getText());
			}
			catch(Exception ex) {
				TEMPT_LEVEL_CHANGE_FIELD.setText("set up a numerical value.");
				return;
			}
			
			DesireNerveIF desireNerve = (DesireNerveIF)nerve;
			desireNerve.setDesireMaxElectricPotential(iLevel);
			desireNerve.setDesireElectricPotential(iLevel);
			
		}
		else if("removeCommonPlan".equals(command)) {
			String id = TEMPT_NERVE_ID_FIELD.getText();
			NerveIF nerve = null;
			
			try{
				long key = Long.valueOf(id);
				nerve = DevelopHelper.searchNerve(key);

				if(nerve == null || (nerve instanceof DesireNerveIF) == false) {
					nerve = (NerveIF)DevelopHelper.getMaxDesireNerve();
				}
			}
			catch(Exception ex) {
				//őlɐݒ肷
				nerve = (NerveIF)DevelopHelper.getMaxDesireNerve();
			}
			
			if(nerve == null) {
				return;
			}
			
			int iIndex = 0;
			try {
				iIndex = Integer.valueOf(COMMON_PLAN_REMOVE_FIELD.getText());
			}
			catch(Exception ex) {
				COMMON_PLAN_REMOVE_FIELD.setText("set up a numerical value.");
				return;
			}
			
			DesireNerveIF desireNerve = (DesireNerveIF)nerve;
			List<List<DesireNerveIF>> targetDesireNerve = desireNerve.getSuccessCommonDesireList();
			targetDesireNerve.remove(iIndex);
			
		}
		else if("savememory".equals(command)) {
			int option = JOptionPane.showConfirmDialog(this, "Memory is saved. Is it all right? \n(It takes about " +
					AICoreConst.MAX_EXEC_CONTDITION_TIME / 1000 + " seconds.)");
			if(option == JOptionPane.YES_OPTION) {
				if(MemoryControler.outputMemory()) {
					JOptionPane.showMessageDialog(this, "It succeeded in preservation of memory.");
				}
				else {
					JOptionPane.showMessageDialog(this, "It failed in preservation of memory.");
				}
			}
		}
		else if("loadmemory".equals(command)) {
			int option = JOptionPane.showConfirmDialog(this, "Memory is restored. Is it all right? \n(It takes about " +
					AICoreConst.MAX_EXEC_CONTDITION_TIME / 1000 + " seconds.)");
			if(option == JOptionPane.YES_OPTION) {
				if(MemoryControler.inputMemory()) {
					JOptionPane.showMessageDialog(this, "It succeeded in restoration of memory.");
				}
				else {
					JOptionPane.showMessageDialog(this, "It failed in restoration of memory.");
				}
			}
		}
		else if("recodesignal".equals(command)) {
			int option = JOptionPane.showConfirmDialog(this, "Record of signal data is started for high-speed education.\nIs it all right?");
			if(option == JOptionPane.YES_OPTION) {
				if(MemoryControler.startEducationOutput()) {
					JOptionPane.showMessageDialog(this, "Record was started.");
				}
				else {
					JOptionPane.showMessageDialog(this, "Record was not started.");
				}
			}
		}
		else if("stoprecode".equals(command)) {
			int option = JOptionPane.showConfirmDialog(this, "Record of signal data is stoped for high-speed education.\nIs it all right?");
			if(option == JOptionPane.YES_OPTION) {
				if(MemoryControler.stopEducationOutput()) {
					JOptionPane.showMessageDialog(this, "Record was stoped.");
				}
				else {
					JOptionPane.showMessageDialog(this, "Record was not stoped.");
				}
			}
		}
		else if("starteducation".equals(command)) {
			int option = JOptionPane.showConfirmDialog(this, "Education is started based on the recorded data. Is it all right?\n(It takes about " +
				MemoryControler.getSignalDataCount() * LightGenerator.LIGHT_INTERVAL / 1000 + " seconds.)");
			if(option == JOptionPane.YES_OPTION) {
				if(MemoryControler.inputEducation()) {
					JOptionPane.showMessageDialog(this, "High-speed education was completed.");
				}
				else {
					JOptionPane.showMessageDialog(this, "High-speed education was failed.");
				}
			}
		}
		
	}

}
