package jp.co.celestee.external.object.avatar;

import java.awt.Point;
import java.awt.Polygon;
import java.util.Arrays;

@SuppressWarnings("serial")
public abstract class AbstractAvatarPolygon extends Polygon {

	protected int[] xpoints = null;
	protected int[] ypoints = null;
	protected int addX = 0;
	protected int addY = 0;
	protected String polygonName = null;
	
	public AbstractAvatarPolygon(int[] x, int[] y, int length, String name) {
		super(x, y, length);
		xpoints = x;
		ypoints = y;
		polygonName = name;
	}
	
	@Override
	public String toString() {
		return polygonName + " " + addX + "," + addY;
	}
	
	protected void setAddX(int x) {
		addX = x;
	}
	
	protected void setAddY(int y) {
		addY = y;
	}
	
	public int[] getXpoints() {
		return xpoints;
	}

	public int[] getYpoints() {
		return ypoints;
	}

	public int getAddX() {
		return addX;
	}

	public int getAddY() {
		return addY;
	}

	public String getTostring() {
		return polygonName;
	}

	/**
	 * Rs[Aʒutĕԋp܂B
	 * @param x
	 * @param y
	 * @return
	 */
	public AbstractAvatarPolygon cloneAndAdd(Point point) {
		AbstractAvatarPolygon polygon = deepCopy();
		polygon.setAddX(point.x);
		polygon.setAddY(point.y);
		return polygon;
	}
	
	/**
	 * NXł́Ag̃fB[vRs[Ԃ܂
	 * @return
	 */
	protected abstract AbstractAvatarPolygon deepCopy();
	
	@Override
	public boolean equals(Object target) {
		boolean b = super.equals(target);
		if(b) return b;
		
		if(target instanceof AbstractAvatarPolygon) {
			AbstractAvatarPolygon polygon = (AbstractAvatarPolygon)target;
			boolean bX = xpoints == null ? polygon.xpoints == null : Arrays.equals(xpoints, polygon.xpoints);
			boolean bY = ypoints == null ? polygon.ypoints == null : Arrays.equals(ypoints, polygon.ypoints);
			boolean bAddX = addX == polygon.addX;
			boolean bAddY = addY == polygon.addY;
			
			return bX && bY && bAddX && bAddY;
		}
		
		return false;
	}

}
