package jp.co.celestee.external.object.avatar;

import java.awt.Color;
import java.awt.Point;

import jp.co.celestee.external.object.EnergyOrangeObj;
import jp.co.celestee.external.object.ObjectLinkManager;
import jp.co.celestee.external.object.TimerSoundPlayer;
import jp.co.celestee.external.virtual.AvatarMap;

public class SoundButton extends AbstractAvatar {

	public SoundButton(Point location) {
		super(new Object());
		
		this.setLocation(location);
		
		@SuppressWarnings("serial")
		Color color = new Color(0, 255, 0){
			public String toString() {
				return "SOUNDBUTTON ";
			}
		};

		this.setColor(color);
		
		int[] xpoints = new int[]{19, 25, 25,  2,  2,  8,  8, 19};
		int[] ypoints = new int[]{14, 14, 25, 25, 14, 14,  4,  4};
		
		ButtonPolygon polygon = new ButtonPolygon(xpoints, ypoints, xpoints.length, "BUTTON");
		setPolygon(polygon);
		
		setType(AvatarMap.OBJ_TYPE_CAN_BREAK);

		AvatarIF avatar = ObjectLinkManager.getAvatar(EnergyOrangeObj.getInstance());
		if(avatar != null) {
			avatar.setType(AvatarMap.OBJ_TYPE_NOT_CAN_BREAK);
		}

	}

	@Override
	public void addImpact(int impact) {
		//Ռ^ƈ莞ԉ
		this.remove();
		
		System.out.println("tJn");
		
		TimerSoundPlayer timer = new TimerSoundPlayer();
		timer.start();
		
		AvatarIF avatar = ObjectLinkManager.getAvatar(EnergyOrangeObj.getInstance());
		if(avatar != null) {
			avatar.setType(AvatarMap.OBJ_TYPE_CAN_BREAK);
		}
	}
	
//	@Override
//	public Polygon getLookedPolygon(Point lookingPoint) {
//		ButtonPolygon polygon = (ButtonPolygon)getPolygon();
//		return polygon.cloneAndAdd(lookingPoint);
//	}

}
