package jp.co.celestee.external.object.avatar;

import java.awt.Color;
import java.awt.Point;
import java.awt.Polygon;

import jp.co.celestee.external.virtual.AvatarMap;

public class Wall extends AbstractAvatar {

	public Wall(Point location) {
		super(new Object());
		
		this.setLocation(location);
		
		@SuppressWarnings("serial")
		Color color = new Color(50 + location.x, 0, 200 + location.y){
			public String toString() {
				return "WALL " + (getRed() - 50) + "," + (getBlue() - 200);
			}
		};
		
		this.setColor(color);
		
		int[] xpoints = new int[]{ 5, 14, 23, 26, 17, 26, 23, 14,  5,  2, 11,  2};
		int[] ypoints = new int[]{ 2, 11,  2,  5, 14, 23, 26, 17, 26, 23, 14,  5};
		
		WallPolygon polygon = new WallPolygon(xpoints, ypoints, xpoints.length, "WALL");
		setPolygon(polygon);
		
		setWeight(100);
		
		setType(AvatarMap.OBJ_TYPE_NOT_CAN_BREAK);

	}

	@Override
	public void addImpact(int impact) {
	}
	
	@Override
	public Polygon getLookedPolygon(Point lookingPoint) {
		WallPolygon polygon = (WallPolygon)getPolygon();
		return polygon.cloneAndAdd(lookingPoint);
	}

}
