package jp.co.celestee.external.rule.dinamic;

import java.util.ArrayList;
import java.util.List;

import jp.co.celestee.external.event.DynamicToRuleEventConveter;
import jp.co.celestee.external.rule.RuleAccessorIF;
import jp.co.celestee.external.rule.RuleDataIF;
import jp.co.celestee.external.rule.RuleIF;
import jp.co.celestee.external.rule.RuleManager;
import jp.co.celestee.external.virtual.JRuleFrame;

public class DynamicRule implements RuleIF {

	public static final int DYNAMIC_RULE = 3;

	List<DynamicRuleAccessorIF> _list = new ArrayList<DynamicRuleAccessorIF>();
	
	public DynamicRule() {
		RuleManager ruleManager = RuleManager.getInstance();
		ruleManager.setRule(DYNAMIC_RULE, this);
	}

	/**
	 * eIF烋[ւ̓([ɑ݂Ă铮͂󂯕t镨̑SĂΏ)
	 */
	public void input(RuleDataIF ruleData) {
		DynamicRuleData dRuleData = (DynamicRuleData)ruleData;
		int iAction = dRuleData.getDynamic();
		
		if(_list.contains(dRuleData.getObject()) == false) {
			throw new UnsupportedOperationException();
		}
		
		if(iAction == DynamicToRuleEventConveter.GO_ACTION) {
			DynamicToRuleEventConveter.go(dRuleData.getObject());
		}
		else if(iAction == DynamicToRuleEventConveter.TURN_RIGHT_ACTION) {
			DynamicToRuleEventConveter.turnRight(dRuleData.getObject());
		}
		else if(iAction == DynamicToRuleEventConveter.TURN_LEFT_ACTION) {
			DynamicToRuleEventConveter.turnLeft(dRuleData.getObject());
		}
		else if(iAction == DynamicToRuleEventConveter.ABSORPTION_ACTION) {
			DynamicToRuleEventConveter.absorption(dRuleData.getObject());
		}
		else if(iAction == DynamicToRuleEventConveter.LIFT_ACTION) {
			DynamicToRuleEventConveter.lift(dRuleData.getObject());
		}
		
		//ĕ`
		JRuleFrame.getInstance().getAvatarMap().repaint();
	}
	
	/**
	 * [eIF֏o([ɑ݂Ă铮͂󂯕t镨̑SĂɏo͂)
	 */
	public void output(RuleDataIF ruleData) {
		DynamicRuleData dRuleData = (DynamicRuleData)ruleData;

		//h̑MΏ
		DynamicRuleAccessorIF dynamicRuleIF = (DynamicRuleAccessorIF)dRuleData.getObject();
		
		if(dynamicRuleIF == null) {
			//h̑MΏۂȂΑSĂɍs
			for(DynamicRuleAccessorIF accessIF : _list) {
				accessIF.inputDynamic(dRuleData);
			}
		}
		else {
			//w肪ΒPɎs
			if(_list.contains(dynamicRuleIF)) {
				dynamicRuleIF.inputDynamic(dRuleData);
			}
			else {
				throw new UnsupportedOperationException();
			}
		}
		
		//ĕ`
		JRuleFrame.getInstance().getAvatarMap().repaint();
	}
	
	/**
	 * ̓f[^󂯕t镨̂Ƃă[ɓo^B
	 */
	public void entry(RuleAccessorIF ruleAccessor) {
		_list.add((DynamicRuleAccessorIF)ruleAccessor);
	}

}
