package jp.co.celestee.external.virtual;

import java.awt.Color;
import java.awt.Point;
import java.awt.Polygon;
import java.util.ArrayList;
import java.util.List;

import jp.co.celestee.external.object.avatar.AvatarIF;
import jp.co.celestee.external.object.avatar.FloorColor;
import jp.co.celestee.external.object.avatar.FloorPolygon;

public class AvatarMap {

	/** k */
	public static final Point DIRECTION_NORTH = new Point(0, -1);
	
	/**  */
	public static final Point DIRECTION_SOUTH = new Point(0, 1);
	
	/**  */
	public static final Point DIRECTION_EAST = new Point(1, 0);

	/**  */
	public static final Point DIRECTION_WEST = new Point(-1, 0);

	public static final List<Point> DIRECTION_LIST = new ArrayList<Point>(4);

	/** ̋`(k) */
	public static FloorPolygon NORTH_FLOOR_POLYGON = null;

	/** ̋`() */
	public static FloorPolygon SOUTH_FLOOR_POLYGON = null;

	/** ̋`() */
	public static FloorPolygon EAST_FLOOR_POLYGON = null;

	/** ̋`() */
	public static FloorPolygon WEST_FLOOR_POLYGON = null;

	/** 󂹂Ȃ */
	public static final int OBJ_TYPE_NOT_CAN_BREAK = 1;
	
	/** 󂹂镨 */
	public static final int OBJ_TYPE_CAN_BREAK = 2;
	
	/** }bṽTCY@` */
	private static int mapSize = 10;

	/** MAPɐݒ肷Ao^[ */
	private static AvatarIF avatars[][] = new AvatarIF[mapSize][mapSize];
	
	/** ̐F */
	private static Color floor[][] = new Color[mapSize][mapSize];

	static {
		//kXg
		DIRECTION_LIST.add(DIRECTION_NORTH);
		DIRECTION_LIST.add(DIRECTION_SOUTH);
		DIRECTION_LIST.add(DIRECTION_EAST);
		DIRECTION_LIST.add(DIRECTION_WEST);

		//̌`(k)
		int[] xpointsN = new int[]{ 0, 1, 27, 27,  0};
		int[] ypointsN = new int[]{ 1, 0,  0, 27, 27};
		
		NORTH_FLOOR_POLYGON = new FloorPolygon(xpointsN, ypointsN, xpointsN.length, "FLOOR_N");

		//̌`()
		int[] xpointsS = new int[]{ 0, 27, 27, 26,  0};
		int[] ypointsS = new int[]{ 0,  0, 26, 27, 27};
		
		SOUTH_FLOOR_POLYGON = new FloorPolygon(xpointsS, ypointsS, xpointsS.length, "FLOOR_S");

		//̌`()
		int[] xpointsE = new int[]{ 0, 26, 27, 27,  0};
		int[] ypointsE = new int[]{ 0,  0,  1, 27, 27};
		
		EAST_FLOOR_POLYGON = new FloorPolygon(xpointsE, ypointsE, xpointsE.length, "FLOOR_E");

		//̌`()
		int[] xpointsW = new int[]{ 0, 27, 27,  1,  0};
		int[] ypointsW = new int[]{ 0,  0, 27, 27, 26};
		
		WEST_FLOOR_POLYGON = new FloorPolygon(xpointsW, ypointsW, xpointsW.length, "FLOOR_W");

		//̐F ݒ
		int iColor = 142;
		for(int y = 0; y < mapSize; y++){
			for(int x = 0; x < mapSize; x++){
				floor[x][y] = new FloorColor(102, iColor, 255, x, y);
				iColor++;
			}
		}

	}
	
	/**
	 * }bvTCY擾܂
	 * @return
	 */
	public static int getMapSize() {
		return mapSize;
	}
	
	/**
	 * ̐F}bv擾܂
	 * @return
	 */
	public static Color[][] getFloorMap() {
		return floor;
	}
	
	/**
	 * w肵ʒũAo^[擾܂
	 * @param destinationPoint
	 * @return
	 */
	public static AvatarIF getAvatar(Point destinationPoint) {
		if(isMap(destinationPoint)) {
			return avatars[destinationPoint.x][destinationPoint.y];
		}
		return null;
	}
	
	/**
	 * w肵ʒuɃAo^[ݒ肵܂B
	 * @param point
	 * @param avatar
	 */
	public static void setAvatar(AvatarIF avatar) {
		avatars[avatar.getLocation().x][avatar.getLocation().y] = avatar;
	}

	/**
	 * w肵ʒũAo^[擾܂
	 * @param destinationPoint
	 * @return
	 */
	public static AvatarIF getAvatar(int x, int y) {
		if(isMap(new Point(x, y))) {
			return avatars[x][y];
		}
		return null;
	}

	/**
	 * w肵Ao^[܂
	 * @param avatar
	 */
	public static void removeAvatar(AvatarIF avatar) {
		if(avatar != null && avatar.getLocation() != null) {
			avatars[avatar.getLocation().x][avatar.getLocation().y] = null;
		}
	}

	/**
	 * s̈ʒu擾܂
	 * @param point
	 * @param directionPoint
	 * @return
	 */
	public static Point getPoint(Point point, Point directionPoint) {
		return new Point(point.x + directionPoint.x, point.y + directionPoint.y);
	}

	/**
	 * 1Oi܂
	 * @param avatar
	 */
	public static void go(AvatarIF avatar) {
		avatars[avatar.getLocation().x][avatar.getLocation().y] = null;
		
		Point point = avatar.getLocation();
		Point directionPoint = avatar.getDirection();
		//s̈ʒu
		Point destinationPoint = getPoint(point, directionPoint);
		
		avatar.setLocation(destinationPoint);
		setAvatar(avatar);
	}
	
	/**
	 * w̃Ao^[֐i߂邩肵܂
	 * @param avatar
	 * @return
	 */
	public static boolean checkGo(AvatarIF avatar) {
		Point point = avatar.getLocation();
		Point directionPoint = avatar.getDirection();
		//s̈ʒu
		Point destinationPoint = getPoint(point, directionPoint);
		if(isMap(destinationPoint) == false) {
			return false;
		}
		//s̃Ao^[
		AvatarIF destinationAvatar = getAvatar(destinationPoint);
		
		if(destinationAvatar == null) {
			return true;
		}
		
		return destinationAvatar.isThrough();
	}
	
	/**
	 * ڂ̑ÕAo^[擾܂B
	 * @param avatar
	 * @return
	 */
	public static AvatarIF getFrontAvatar(AvatarIF avatar) {
		Point point = avatar.getLocation();
		Point directionPoint = avatar.getDirection();
		//ʂ̈ʒu
		Point destinationPoint = getPoint(point, directionPoint);
		if(isMap(destinationPoint) == false) {
			return null;
		}
		//ʂ̃Ao^[
		AvatarIF destinationAvatar = getAvatar(destinationPoint);
		
		return destinationAvatar;
	}
	
	/**
	 * ЂƂ܂㉺Ê݂Ŏ΂ߖŔ˂̉e^Ao^[擾
	 * @param avatar
	 * @return
	 */
	public static List<AvatarIF> aroundReflectAvatar(AvatarIF avatar) {
		Point point = avatar.getLocation();
		List<AvatarIF> avatarList = null;
		
		for(Point directionPoint : DIRECTION_LIST) {
			Point targetPoint = getPoint(point, directionPoint);
			AvatarIF targetAvatar = getAvatar(targetPoint);
			
			if(targetAvatar != null && avatar.isAcceptedLight(targetPoint)) {
				if(avatarList == null) {
					avatarList = new ArrayList<AvatarIF>(4);
				}
				avatarList.add(targetAvatar);
			}
		}
		
		return avatarList;
	}
	
	/**
	 * ̐FԂ܂
	 * @param point
	 * @return
	 */
	public static Color getFloorColor(Point point) {
		if(isMap(point)) {
			return floor[point.x][point.y];
		}
		
		return null;
	}
	
	/**
	 * ̋`擾܂
	 * @param point
	 * @param watchedDirectionPoint ĂiĂAo^[ĂjBAo^[EASTɂWESTɂȂB
	 * @return
	 */
	public static Polygon getFloorPolygon(Point point, Point watchedDirectionPoint) {
		if(isMap(point)) {
			if(watchedDirectionPoint == DIRECTION_NORTH) {
				return NORTH_FLOOR_POLYGON.cloneAndAdd(point);
			}
			else if(watchedDirectionPoint == DIRECTION_SOUTH) {
				return SOUTH_FLOOR_POLYGON.cloneAndAdd(point);
			}
			else if(watchedDirectionPoint == DIRECTION_EAST) {
				return EAST_FLOOR_POLYGON.cloneAndAdd(point);
			}
			else if(watchedDirectionPoint == DIRECTION_WEST) {
				return WEST_FLOOR_POLYGON.cloneAndAdd(point);
			}
		}
		
		return null;
	}

	/**
	 * wʒuMAP܂B
	 * @param point
	 * @return
	 */
	public static boolean isMap(Point point) {
		if(point == null) {
			return false;
		}
		
		if(point.x < 0 || point.y < 0 || point.x >= mapSize || point.y >= mapSize) {
			return false;
		}
		
		return true;
	}
	
	/**
	 * MAPO̐FԂ܂
	 * @param point
	 * @return
	 */
	public static Color getOutofMapColor(Point point) {
		if(isMap(point)) {
			return null;
		}
		
		int iColor = point.x + (point.y * 10) + 70;
		
		return new FloorColor(iColor, iColor, iColor, point.x, point.y);
	}
	
}
