package jp.co.celestee.external.virtual;

import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.Element;

import jp.co.celestee.external.object.EnergyOrangeObj;
import jp.co.celestee.external.object.EnergyRedObj;
import jp.co.celestee.external.object.EnergyWhiteObj;
import jp.co.celestee.external.object.LightGenerator;
import jp.co.celestee.external.object.ObjectLinkManager;
import jp.co.celestee.external.object.avatar.AvatarIF;
import jp.co.celestee.external.object.avatar.EnergyRed;
import jp.co.celestee.external.object.avatar.EnergyWhite;
import jp.co.celestee.external.object.avatar.EnergyYellow;
import jp.co.celestee.external.object.avatar.SoundButton;
import jp.co.celestee.external.object.avatar.Stone;
import jp.co.celestee.external.rule.sound.SoundRuleAccessorIF;
import jp.co.celestee.external.rule.sound.SoundRuleData;

@SuppressWarnings("serial")
public class JRuleFrame extends JFrame  implements SoundRuleAccessorIF, ActionListener {

	private static JRuleFrame _substatnce = new JRuleFrame();
	
	private static long _line = 0;
	
	/** g̓GA */
	private JTextArea LOUDSPEAKER_AREA = null;
	
	/** [ɏo͂ꂽLڂ܂B */
	private JTextArea SOUND_RULE_AREA = null;

	/** Ao^[`悷̈ */
	private JAvatarMap AVATAR_MAP = null;
	
	private JToggleButton lightOnOffButton = null;
	private JButton stoneButton = null;
	private JButton energyButtonY = null;
	private JButton energyButtonW = null;
	private JButton energyButtonR = null;
	private JButton soundButton = null;
	
	private JTextField pointXfield = null;
	private JTextField pointYfield = null;
	
	private JRuleFrame() {
		JPanel basePane = new JPanel();
		getContentPane().add(basePane);
		
		basePane.setLayout(new BoxLayout(basePane, BoxLayout.X_AXIS));
		basePane.setSize(520, 720);
		

		//PANEL
		JPanel mapPane = new JPanel();
		mapPane.setLayout(new BoxLayout(mapPane, BoxLayout.Y_AXIS));
		mapPane.setSize(400, 720);
		basePane.add(mapPane);
		
		//㕔(MAP)
		mapPane.add(new JLabel("small world"));
		AVATAR_MAP = new JAvatarMap();
		AVATAR_MAP.setBorder(BorderFactory.createLoweredBevelBorder());
		JScrollPane scrollPane1 = new JScrollPane(AVATAR_MAP);
		scrollPane1.setPreferredSize(new Dimension(0, 380));
		scrollPane1.setMinimumSize(new Dimension(0, 380));
		mapPane.add(scrollPane1);

		//(all soundj
		mapPane.add(new JLabel("Sound which sounds in the small world "));
		SOUND_RULE_AREA = new JTextArea(20, 6);
		SOUND_RULE_AREA.setEditable(false);
		JScrollPane scrollPane2 = new JScrollPane(SOUND_RULE_AREA);
		scrollPane2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane2.setPreferredSize(new Dimension(360, 240));
		mapPane.add(scrollPane2);
		
		SOUND_RULE_AREA.getDocument().addDocumentListener(new DocumentListener() {
			@Override
			public void insertUpdate(DocumentEvent e) {
				final Document doc = SOUND_RULE_AREA.getDocument();
				final Element rootElement = doc.getDefaultRootElement();
				if(rootElement.getElementCount() <= 11) {
					return;
				}
				EventQueue.invokeLater(new Runnable() {
					@Override
					public void run() {
						removeLines(doc, rootElement);
					}
				});
				SOUND_RULE_AREA.setCaretPosition(doc.getLength());
			}
			
			private void removeLines(Document doc, Element rootElement) {
				Element fl = rootElement.getElement(0);
				try{
					doc.remove(0, fl.getEndOffset());
				}
				catch(BadLocationException e) {
					System.out.println(e);
				}
			}
			
			@Override
			public void removeUpdate(DocumentEvent e) {}
			
			@Override
			public void changedUpdate(DocumentEvent e) {}
		});


		//(Loudspeaker)
		mapPane.add(new JLabel("LoudSpeaker (it can kick in the talk to the small world)"));
		LOUDSPEAKER_AREA = new JTextArea(20, 2);
		JScrollPane scrollPane3 = new JScrollPane(LOUDSPEAKER_AREA);
		scrollPane3.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollPane3.setPreferredSize(new Dimension(360, 40));
		mapPane.add(scrollPane3);

		//{^PANEL
		JPanel actionPane = new JPanel();
		actionPane.setLayout(new BoxLayout(actionPane, BoxLayout.Y_AXIS));
		actionPane.setSize(120, 700);
		basePane.add(actionPane);
		
		//x
		JLabel influLabel = new JLabel("[ Effect ]");
		influLabel.setMaximumSize(new Dimension(120, 25));
		influLabel.setMinimumSize(new Dimension(120, 25));
		actionPane.add(influLabel);
		
		//Cg on/off
		lightOnOffButton = new JToggleButton("lighting..", true);
		lightOnOffButton.setMaximumSize(new Dimension(105, 25));
		lightOnOffButton.setMinimumSize(new Dimension(105, 25));
		lightOnOffButton.addActionListener(this);
		actionPane.add(lightOnOffButton);

		//Energyu(F)
		energyButtonY = new JButton("energy Y");
		energyButtonY.setMaximumSize(new Dimension(105, 25));
		energyButtonY.setMinimumSize(new Dimension(105, 25));
		energyButtonY.addActionListener(this);
		actionPane.add(energyButtonY);

		//Energyu(F)
		energyButtonW = new JButton("energy W");
		energyButtonW.setMaximumSize(new Dimension(105, 25));
		energyButtonW.setMinimumSize(new Dimension(105, 25));
		energyButtonW.addActionListener(this);
		actionPane.add(energyButtonW);

		//Energyu(ԐF)
		energyButtonR = new JButton("energy R");
		energyButtonR.setMaximumSize(new Dimension(105, 25));
		energyButtonR.setMinimumSize(new Dimension(105, 25));
		energyButtonR.addActionListener(this);
		actionPane.add(energyButtonR);

		//SoundButtonu
		soundButton = new JButton("button");
		soundButton.setMaximumSize(new Dimension(105, 25));
		soundButton.setMinimumSize(new Dimension(105, 25));
		soundButton.addActionListener(this);
		actionPane.add(soundButton);

		//΂u
		stoneButton = new JButton("stone");
		stoneButton.setMaximumSize(new Dimension(105, 25));
		stoneButton.setMinimumSize(new Dimension(105, 25));
		stoneButton.addActionListener(this);
		actionPane.add(stoneButton);

		//x
		JLabel pointLabel = new JLabel("[ Stone Effect ]");
		pointLabel.setMaximumSize(new Dimension(120, 25));
		pointLabel.setMinimumSize(new Dimension(120, 25));
		actionPane.add(pointLabel);

		JLabel xLabel = new JLabel("  x = ");
		xLabel.setMaximumSize(new Dimension(120, 20));
		xLabel.setMinimumSize(new Dimension(120, 20));
		actionPane.add(xLabel);

		pointXfield = new JTextField("5", 1);
		pointXfield.setMaximumSize(new Dimension(100, 20));
		actionPane.add(pointXfield);

		JLabel yLabel = new JLabel("  y = ");
		yLabel.setMaximumSize(new Dimension(120, 20));
		yLabel.setMinimumSize(new Dimension(120, 20));
		actionPane.add(yLabel);

		pointYfield = new JTextField("5", 1);
		pointYfield.setMaximumSize(new Dimension(100, 20));
		actionPane.add(pointYfield);

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("Small World");
		setSize(520, 720);
		setVisible(true);
		//setAlwaysOnTop(true);
		setLocation(500, 0);
		LOUDSPEAKER_AREA.setFocusable(true);
		
	}
	
	public static JRuleFrame getInstance() {
		return _substatnce;
	}
	
	public JAvatarMap getAvatarMap() {
		return AVATAR_MAP;
	}
	
	public JTextArea getLoudspeakerArea() {
		return LOUDSPEAKER_AREA;
	}
	
	public void setOutputCharacter(String s) {
		String sText = SOUND_RULE_AREA.getText();
		SOUND_RULE_AREA.setText(sText + s);
	}
	
	/**
	 * [ɓ͂ꂽeLXgGAɕ\܂B
	 */
	public void inputSound(SoundRuleData ruleData) {
		
		int iSize = String.valueOf(_line).length();
		setOutputCharacter("(" + "000".substring(iSize) + _line + ") " + ruleData.getContents() 
				+ " [Type=" + ruleData.getType() + " : Potential=" + ruleData.getPotential() + "]\n");
		
		_line++;
		_line = _line > 999 ? 0 : _line;
	}
	
	public void actionPerformed(ActionEvent e){

		if(e.getActionCommand().equals("lighting..")) {
			lightOnOffButton.setText("light");
			LightGenerator.setPotential(0);
		}
		else if(e.getActionCommand().equals("light")) {
			lightOnOffButton.setText("lighting..");
			LightGenerator.setPotential(30);
		}
		else if(e.getActionCommand().equals("energy Y")) {
			AvatarIF avatar = ObjectLinkManager.getAvatar(EnergyOrangeObj.getInstance());
			if(avatar == null) {
				new EnergyYellow(new Point(1, 2));
				AVATAR_MAP.repaint();
			}
		}
		else if(e.getActionCommand().equals("energy W")) {
			AvatarIF avatar = ObjectLinkManager.getAvatar(EnergyWhiteObj.getInstance());
			if(avatar == null) {
				new EnergyWhite(new Point(4, 4));
				AVATAR_MAP.repaint();
			}
		}
		else if(e.getActionCommand().equals("energy R")) {
			AvatarIF avatar = ObjectLinkManager.getAvatar(EnergyRedObj.getInstance());
			if(avatar == null) {
				new EnergyRed(new Point(5, 2));
				AVATAR_MAP.repaint();
			}
		}
		else if(e.getActionCommand().equals("button")) {
			AvatarIF avatar = AvatarMap.getAvatar(2, 5);
			if(avatar == null) {
				new SoundButton(new Point(2, 5));
				AVATAR_MAP.repaint();
			}
			
		}
		else if(e.getActionCommand().equals("stone")) {
			Point point = getStoneEffectPoint();
			if(point != null) {
				AvatarIF avatar = AvatarMap.getAvatar(point.x, point.y);
				if(avatar == null) {
					new Stone(point);
					AVATAR_MAP.repaint();
				}
			}
		}
	}
	
	private Point getStoneEffectPoint() {
		
		Point point = null;
		
		try{
			point = new Point(Integer.valueOf(pointXfield.getText()), Integer.valueOf(pointYfield.getText()));
		}
		catch(Exception ex) {
			ex.printStackTrace();
		}
		
		return point;
	}
}
