package jp.co.celestee.ai.main;

import java.awt.Point;

import jp.co.celestee.ai.interfaces.body.BodySubstance;
import jp.co.celestee.ai.interfaces.characterin.CharacterInSubstance;
import jp.co.celestee.ai.interfaces.image.ImageSubstance;
import jp.co.celestee.external.object.LightGenerator;
import jp.co.celestee.external.object.Loudspeaker;
import jp.co.celestee.external.object.avatar.EnergyYellow;
import jp.co.celestee.external.object.avatar.John;
import jp.co.celestee.external.object.avatar.JohnsEye;
import jp.co.celestee.external.object.avatar.SoundButton;
import jp.co.celestee.external.object.avatar.Stone;
import jp.co.celestee.external.object.avatar.Wall;
import jp.co.celestee.external.rule.RuleIF;
import jp.co.celestee.external.rule.RuleManager;
import jp.co.celestee.external.rule.dinamic.DynamicRule;
import jp.co.celestee.external.rule.light.LightRule;
import jp.co.celestee.external.rule.sound.SoundRule;
import jp.co.celestee.external.virtual.JRuleFrame;

/**
 * K͐EgݗĂ܂B
 * @author celestee
 *
 */
public class SmallWorldBuilder {

	public static void buildWorld() {
		
		JRuleFrame frame = JRuleFrame.getInstance();
		
		//geLXgGAƊ֘At
		Loudspeaker loudSpeaker = Loudspeaker.getInstance();
		loudSpeaker.setMonitor(frame.getLoudspeakerArea());
		
		//̔ݒ肷
		LightGenerator lightGeneraotor = new LightGenerator();
		
		//[Kpi[j
		RuleIF characterRule = RuleManager.getInstance().getRule(SoundRule.SOUND_RULE);
		characterRule.entry(CharacterInSubstance.getInstance());
		characterRule.entry(frame);
		
		//[Kpi摜[j
		RuleIF imageRule = RuleManager.getInstance().getRule(LightRule.LIGHT_RULE);
		imageRule.entry(ImageSubstance.getInstance());

		//[Kpi͂̃[j
		RuleIF dynamicRule = RuleManager.getInstance().getRule(DynamicRule.DYNAMIC_RULE);
		dynamicRule.entry(BodySubstance.getInstance());

		//Ao^[̍쐬
		John john = new John(BodySubstance.getInstance(), new Point(5, 7));
		new JohnsEye(ImageSubstance.getInstance(), john);
		
		new EnergyYellow(new Point(1, 2));
		//new EnergyRed(new Point(8, 4));
		new SoundButton(new Point(2, 5));
		new Stone(new Point(5, 5));

		//Og
		new Wall(new Point(0, 1));
		new Wall(new Point(1, 1));
		new Wall(new Point(2, 1));
		new Wall(new Point(3, 1));
		new Wall(new Point(4, 1));
		new Wall(new Point(5, 1));
		new Wall(new Point(6, 1));

		new Wall(new Point(0, 8));
		new Wall(new Point(1, 8));
		new Wall(new Point(2, 8));
		new Wall(new Point(3, 8));
		new Wall(new Point(4, 8));
		new Wall(new Point(5, 8));
		new Wall(new Point(6, 8));

		new Wall(new Point(0, 2));
		new Wall(new Point(0, 3));
		new Wall(new Point(0, 4));
		new Wall(new Point(0, 5));
		new Wall(new Point(0, 6));
		new Wall(new Point(0, 7));
		
		new Wall(new Point(6, 2));
		new Wall(new Point(6, 3));
		new Wall(new Point(6, 4));
		new Wall(new Point(6, 5));
		new Wall(new Point(6, 6));
		new Wall(new Point(6, 7));

		//
		new Wall(new Point(2, 3));
		new Wall(new Point(2, 4));
		//new Wall(new Point(2, 5));
		new Wall(new Point(2, 6));

		new Wall(new Point(3, 3));
		new Wall(new Point(3, 4));
		new Wall(new Point(3, 5));
		new Wall(new Point(3, 6));

		frame.repaint();
		
		loudSpeaker.start();
		lightGeneraotor.start();
		
	}
}
